# Copyright 2020 Unlimited Robotics
import json
import subprocess

from rayasdk.container_handlers.docker_handler import kill_apps
from rayasdk.logger import log_error, log_verbose, log_info
from rayasdk.constants import *
from rayasdk.utils import *


class URKiller:

    COMMAND = 'kill'

    def __init__(self):
        pass

    def init_parser(self, subparser):
        self.parser = subparser.add_parser(
            type(self).COMMAND,
            help="kills all the running apps on the Ra-Ya container.")

    def run(self, args, unknownargs):
        self.args = args
        self.unknownargs = unknownargs

        connection_settings = open_connection_file()

        if connection_settings[JSON_EXECINFO_SIM]:
            kill_apps()
        else:
            host = connection_settings[JSON_EXECINFO_ROBCONN][
                JSON_EXECINFO_ROBIP]
            host_url = f'{SSH_USER}@{host}'
            self.kill_apps_robot(host_url=host_url)

        log_info('\nDone!')
        return True

    def kill_apps_robot(self, host_url):
        log_info(f'Killing all running apps...')
        cmd = 'pkill -9 -u rayadevel'
        command = (('ssh -t '
                    '-o LogLevel=QUIET '
                    f'-p {SSH_PORT} {host_url} '
                    f'\'{cmd}\''))
        ret = subprocess.call(command, shell=True)
